/*

    File: interface.h

    Copyright (C) 2000-2007 Christopher Moore (christopher.e.moore@gmail.com)
	  
    This software is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.
  
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
  
    You should have received a copy of the GNU General Public License along
    with this program; if not, write the Free Software Foundation, Inc., 51
    Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

*/
#if !defined M_SCRIPT_INTERFACE_H
#define M_SCRIPT_INTERFACE_H

#include <vector>

using namespace std;

class CThreadStackInterface;

#include "program.h"
#include "globalstack.h"	//for global stack

//pass it the predef program int ref #
//use this number as a callback to get parameters and write a return type

/*
 valid primitive types:
	<function pointer>	-	32-bit
	"void"				-	zero bit I suppose
	"bool"				-	32-bit	value of 0 or 1
	"int"				-	32-bit signed
	"float"				-	32-bit floating point
	"entity"			-	32-bit range 0 to entCount-1
	"thread"			-	32-bit thread handle
	"string"			-	32-bit range 0 to program string count

	how i wish it was...
typedef struct {
	int			(*getParamFunc)(int param);
	bool		(*getParamBool)(int param);
	int			(*getParamInt)(int param);
	float		(*getParamFloat)(int param);
	int			(*getParamEntity)(int param);
	int			(*getParamThread)(int param);
	int			(*getParamString)(int param);

	void		(*setReturnFunc)(int ret);
	void		(*setReturnBool)(bool ret);
	void		(*setReturnInt)(int ret);
	void		(*setReturnFloat)(float ret);
	void		(*setReturnEntity)(int ret);
	void		(*setReturnThread)(int ret);
	void		(*setReturnString)(int ret);
} stackInterface_t;
*/

class CThreadStackInterface {
private:
	bool		getParam(int param, void *result, int resultType);
	bool		setReturn(void *result, int resultType);

public:
	CProgram		*program;
	CGlobalStack	*globalStack;
	vector<int>		*dataStack;
	int				func;

	CThreadStackInterface();

	bool		getParamFunc(int param, int *result);
	bool		getParamBool(int param, bool *result);
	bool		getParamInt(int param, int *result);
	bool		getParamFloat(int param, float *result);
	bool		getParamEntity(int param, int *result);
	bool		getParamThread(int param, int *result);
	bool		getParamString(int param, int *result);

	bool		setReturnFunc(int ret);
	bool		setReturnBool(bool ret);
	bool		setReturnInt(int ret);
	bool		setReturnFloat(float ret);
	bool		setReturnEntity(int ret);
	bool		setReturnThread(int ret);
	bool		setReturnString(int ret);

	const char		*getString(int index);
};

#endif
