/*

    File: readfile.h

    Copyright (C) 2000-2007 Christopher Moore (christopher.e.moore@gmail.com)
	  
    This software is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.
  
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
  
    You should have received a copy of the GNU General Public License along
    with this program; if not, write the Free Software Foundation, Inc., 51
    Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

*/
#if !defined M_SCRIPT_READFILE_H
#define M_SCRIPT_READFILE_H

class CReadBuffer {
private:
	void clear(void);
	char *data;
	int size;
	bool gotData;

public:
	CReadBuffer(void);
	CReadBuffer(const char *filename);
	~CReadBuffer(void);

	bool loadFile(const char *filename);

	bool inbounds(int index);
	char getChar(int index);

	bool hasData();

	int getSize();
	const char *getData();

};

#endif