/*

    File: thread.h

    Copyright (C) 2000-2007 Christopher Moore (christopher.e.moore@gmail.com)
	  
    This software is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.
  
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
  
    You should have received a copy of the GNU General Public License along
    with this program; if not, write the Free Software Foundation, Inc., 51
    Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

*/
#if !defined M_SCRIPT_THREAD_H
#define M_SCRIPT_THREAD_H

//since i cant reference "thread.h" - since it is referencing this.
class CProgram;
class CThreadStackInterface;

//#include "program.h"
#include "interface.h"
#include "globalstack.h"

#ifdef DATA_STRING
#include <stack>
#endif

class CScriptThread {
public:

	CProgram *program;
	CGlobalStack *globalStack;
	CThreadStackInterface	sfinterface;

	int ip;			//relative to the program->code
	int bp;

#ifdef DATA_STRING
	vector<int> dataStack;
#else
	int sp;		//relative to the stack
	int dataStack[256];	//unlike C stacks, mine starts at 0 and goes up
#endif

	int getNext();

	void push(int data);
	int pop(void);

	//execute a call...
	bool doCall(int funcIndex);


	bool runNamed(const char *funcname = "main", int *returnBuffer = NULL);
	bool run(int funcIndex, int *returnBuffer = NULL);
	bool reset(int funcIndex, int funcStackSize = 0, int *funcStack = NULL);
	bool doNext();

#ifdef ATTEMPT_IMPLEMENT_FORK
	int fork();
#endif

	CScriptThread(CProgram *program, CGlobalStack *globalStack);
};

#endif